# URL

你可以通过向我们的服务提供你自己的 URL 来获取 Kroger 的结果。我们可以返回你想要的任何 Kroger 页面 HTML。

## 请求样本

下面的示例演示了如何基于特定的商品查询、价格范围和门店位置检索 Kroger 搜索结果页面。

{% tabs %}
{% tab title="cURL" %}

```shell
curl 'https://realtime.oxylabs.io/v1/queries' \\
--user 'USERNAME:PASSWORD' \\
-H 'Content-Type: application/json' \\
-d '{
        "source": "kroger",
        "url": "https://www.kroger.com/search?query=adidas&price=10.00-15.00",
        "store_id": "01100002"
    }'

```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# 结构化负载。
payload = {
    "source": "kroger",
    "url": "https://www.kroger.com/search?query=adidas&price=10.00-15.00",
    "store_id": "01100002",
}

# 获取响应。
response = requests.request(
    "POST",
    "https://realtime.oxylabs.io/v1/queries",
    auth=("USERNAME", "PASSWORD"),
    json=payload,
)

# 将格式化后的响应打印到标准输出。
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "kroger",
    url: "https://www.kroger.com/search?query=adidas&price=10.00-15.00",
    store_id: "01100002",
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("错误：", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="HTTP" %}

```http
https://Realtime.oxylabs.io/v1/queries?source=kroger&url=https%3A%2F%2Fwww.kroger.com%2Fsearch%3Fquery%3Dadidas%26price%3D10.00-15.00&store_id=01100002&access_token=12345abcde
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    "source" => "kroger",
    "url" => "https://www.kroger.com/search?query=adidas&price=10.00-15.00",
    "store_id" => "01100002",
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo '错误:' . curl_error($ch);
}
curl_close($ch);
?>
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
	"bytes"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"net/http"
)

func main() {
	const Username = "USERNAME"
	const Password = "PASSWORD"

	payload := map[string]interface{} {
		"source":   "kroger",
		"url":      "https://www.kroger.com/search?query=adidas&price=10.00-15.00",
		"store_id": "01100002",
	}

	jsonValue, _ := json.Marshal(payload)

	client := &http.Client{}
	request, _ := http.NewRequest("POST",
		"https://realtime.oxylabs.io/v1/queries",
		bytes.NewBuffer(jsonValue),
	)

	request.SetBasicAuth(Username, Password)
	response, _ := client.Do(request)

	responseText, _ := ioutil.ReadAll(response.Body)
	fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "kroger",
                url = "https://www.kroger.com/search?query=adidas&price=10.00-15.00",
                store_id = "01100002"
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;

import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "kroger");
        jsonObject.put("url", "https://www.kroger.com/search?query=adidas&price=10.00-15.00");
        jsonObject.put("store_id", "01100002");

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);

            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("错误： " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "kroger",
    "url": "https://www.kroger.com/search?query=adidas&price=10.00-15.00",
    "store_id": "01100002"
}
```

{% endtab %}
{% endtabs %}

我们在示例中使用同步 [**Realtime**](/products/cn/web-scraper-api/integration-methods/realtime.md) 集成方法。如果您想使用 [**Proxy Endpoint**](/products/cn/web-scraper-api/integration-methods/proxy-endpoint.md) 或异步 [**Push-Pull**](/products/cn/web-scraper-api/integration-methods/push-pull.md) 集成，请参阅 [**集成方法**](/products/cn/web-scraper-api/integration-methods.md) 部分。

## 请求参数值

### 通用

抓取 Kroger 市场的基础设置和自定义选项。

<table><thead><tr><th width="206">参数</th><th width="360.3333333333333">描述</th><th>默认值</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong>source</strong></mark></td><td>设置爬虫。</td><td><code>kroger</code></td></tr><tr><td><mark style="background-color:green;"><strong>url</strong></mark></td><td>任何页面的直接 URL（链接）。</td><td>-</td></tr><tr><td><code>render</code></td><td>设置为时启用 JavaScript 渲染 <code>html</code>. <a href="/spaces/ZwEHB9k4MH4pDy80n9mF/pages/9d7133837001de31de5dfd0796cfbc6fdd7c78c8#javascript-rendering"><strong>更多信息</strong></a><strong>.</strong></td><td>-</td></tr><tr><td><code>callback_url</code></td><td>回调端点的 URL。 <a href="/spaces/ZwEHB9k4MH4pDy80n9mF/pages/f93fe40aed5366f8033cd2ebfae30e61c16a4f51"><strong>更多信息</strong></a></td><td>-</td></tr><tr><td><code>user_agent_type</code></td><td>设备类型和浏览器。完整列表可在 <a href="/spaces/ZwEHB9k4MH4pDy80n9mF/pages/3e6a8ee6a2915a55b276cc31a20735fe1e0e4ed1"><strong>这里</strong></a>.</td><td><code>desktop</code></td></tr></tbody></table>

&#x20;    \- 必填参数

### 本地化

可根据门店位置、配送区域和首选履约方式来自定义结果。

<table><thead><tr><th width="210">参数</th><th width="172.33333333333331">描述</th><th width="153">默认值</th><th>依赖项</th></tr></thead><tbody><tr><td><code>store_id</code></td><td>指定一个门店。请参阅可用值 <a href="https://files.gitbook.com/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FzrXw45naRpCZ0Ku9AjY1%2Fuploads%2FAsihGe7hi5yfauUl2JIQ%2Fkroger_stores.csv?alt=media&#x26;token=40fcd869-1845-47c5-bf76-96e74cabf685"><strong>这里</strong></a>。ID 必须以 '0' 开头。</td><td>-</td><td>在以下情况下必需 <code>fulfillment_type</code> 设置为 <code>自提</code> 或 <code>in_store</code>.</td></tr><tr><td><code>delivery_zip</code></td><td>指定配送地点的 ZIP 代码。</td><td>-</td><td>在以下情况下必需 <code>fulfillment_type</code> 设置为 <code>配送</code>.</td></tr><tr><td><code>fulfillment_type</code></td><td>指定订单履约方式。可用值： <code>自提</code>, <code>配送</code>, <code>in_store</code>.</td><td><code>自提</code> （如果仅提供 <code>store_id</code> ）</td><td>需要 <code>store_id</code> 用于 <code>自提</code> 和 <code>in_store</code>，或 <code>delivery_zip</code> 用于 <code>配送</code>.</td></tr></tbody></table>

**依赖项说明：**

* `自提` 和 `in_store` 值使用 `store_id` 参数来确定正确的门店。
* `配送` 使用 `delivery_zip` 参数来指定配送地点。
* 如果仅提供 `store_id` ，且 `fulfillment_type` 未指定，则默认类型为 `自提`.

{% hint style="warning" %}
如果 `fulfillment_type` 和 `store_id`/`delivery_zip` 组合无效（Kroger 不支持），抓取到的页面将返回 404 状态。
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.oxylabs.io/api-targets/cn/dian-zi-shang-wu/kroger/url.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
